{
Programa tvarkyti duomenu bazei

Programos apribojimai:
    Suderinama su MS Windows (su Linux netestuota);
    Talpina 50 irasu.

Programos istorija:
    2008-11-28 Programa pradeta kurti
    2008-11-29 parasytos funkcijos ReadData, CountData, proceduros PrintData, SearchData
    2008-11-30 parasyta funkcija SortData
    2008-12-02 parasyta funkcija DeleteData
    2008-12-06 parasytos funkcijos ReinsertData, Validator, parasyta dokumentacija

Proceduros:
    PrintData;
    SearchData;

Funkcijos:
    Validator;
    ReadData;
    CountData;
    SortData;
    ReinsertData;
    DeleteData; }

program CamBase;

type ArrStr = array[1..50] of string;
     ArrReal = array[1..50] of real;

type Data = record
            model : ArrStr;   //modelis
            px : ArrReal;     //megapikseliai
            years : ArrStr;   //metai
    end;

var Cam : Data;
    x: Char;

function Validator (years: String): boolean;
         var i, h: Integer;

         begin
            if length(years) > 4 then
                 begin
                    writeln('blogai ivesti metai, klaida galite istaisyti pasirinke meniu punkta "pakeisti".');
                    Validator := False;
                end;
            i:=1;
            h:=1;
            repeat
                begin
                    begin
                        if (copy(years,i,1) >= '0') and (copy(years,i,1) <= '9') then
                        i := i+1;
                    end;
                    h := h+1;
                end;
            until
                h = length(years);                                                   //FixMe, jei metai neatitinka ilgio ir tuo paciu eiluteje netinkami simboliai, metami du vienodi pranesimai
            if i = length(years) then
                Validator := True
            else
                begin
                    writeln('blogai ivesti metai, klaida galite istaisyti pasirinke meniu punkta "pakeisti".');
                    Validator := False;
                end;
         end;

function ReadData (Cam2: Data): Data;
         var model, years: String;
             px: Real;
             num, i: Integer;

         begin
            writeln('Kiek duomenu zadate ivesti?');
            readln(num);
            for i:=1 to num do
              begin
               writeln('Iveskite fotoaparato modeli:');
               readln(model);
               writeln('megapikseliu kieki:');
               readln(px);
               writeln('isleidimo metus:');
               readln(years);
               if Validator(years) then
                    begin
                        Cam2.model[i] := model;
                        Cam2.px[i] := px;
                        Cam2.years[i] := years;
                        ReadData := Cam2;
                    end
               else
                 ReadData := Cam2;
              end;
         end;

function CountData (Cam3:Data):integer;
          var  i, number : integer;

          begin
             i := 1;
             Number := 0;
                     while Cam.px[i] > 0 do
                     begin
                          Number := Number + 1;
                          i := i + 1;
                     end;
                     CountData := Number;
                end;


function SortData (Cam: Data): Data;
         var n, i, j: integer;
             elem1, elem3: string;
             elem2: Real;           //elem tarpinis elementas, masyvo elementu sukeitimui vietomis

                begin
                    n := CountData(Cam);
                     if n=0 then writeln('jus dar neivedete jokiu duomenu!')
                     else
                     begin
                     for i:=1 to n do
                        begin
                            for j:=1 to n-1 do
                                begin
                                    if Cam.px[j] < Cam.px[j+1] then
                                        begin
                                            elem1 := Cam.model[j];
                                            elem2 := Cam.px[j];
                                            elem3 := Cam.years[j];
                                            Cam.model[j] := Cam.model[j+1];
                                            Cam.px[j] := Cam.px[j+1];
                                            Cam.years[j] := Cam.years[j+1];
                                            Cam.model[j+1] := elem1;
                                            Cam.px[j+1] := elem2;
                                            Cam.years[j+1] := elem3;
                                        end;
                                end;
                        end;
                     end;
                    SortData := Cam;
                end;

procedure PrintData (Cam: data);
          var i, num: Integer;

          begin
            num := CountData(Cam);
            for i:=1 to num do
                begin
                    writeln(Cam.model[i], ' ', Cam.px[i]:2:2, ' ', Cam.years[i]);
                end;
          end;

function ReinsertData (Cam3: Data): Data;
         var NewModel, NewYears: String;
             NewPx: Real;
             n, i: Integer;

         begin
            n := CountData(Cam);
            writeln('Kuriuos elemetus norite pakeisti/prirasyti? (rasyti pozicijos nr)');
            readln(i);
            writeln('iveskite modeli');
            readln(NewModel);
            writeln('megapikseliu kieki');
            readln(NewPx);
            writeln('metus');
            readln(NewYears);
            Cam.model[i] := NewModel;
            Cam.px[i] := NewPx;
            Cam.years[i] := NewYears;
            ReinsertData := Cam3;
         end;

function DeleteData (Cam4: Data): Data;
         var delpos, n, i: integer;

         begin
            n := CountData(Cam);
            if n=0 then writeln('jus dar neivedete jokiu duomenu!')
            else
            begin
            writeln('Kuriuos elementus norite istrinti? (rasyti pozicijos nr)');
            readln(DelPos);
            for i:=DelPos to n-1 do
                begin
                    Cam.model[i] := Cam.model[i+1];
                    Cam.px[i] := Cam.px[i+1];
                    Cam.years[i] := Cam.years[i+1];
                end;
                Cam.model[n] :=  '';
                Cam.px[n] := 0;
                Cam.years[n] := '';
            DeleteData := Cam;
            end;
         end;

procedure SearchData (Cam: Data);
          var ByWhat: Char;
              model, years: String;
              n, i, max, min: Integer;

          begin
            writeln('Ieskosite pagal:');
            writeln('[1] Modeli');
            writeln('[2] Didziausia megapiksleiu kieki');
            writeln('[3] Maziausia megapiksleiu kieki');
            writeln('[4] Metus');
            readln(ByWhat);
            case ByWhat of
            '1' :
                begin
                    n := Countdata(Cam);
                    writeln('iveskite ieskoma modeli');
                    readln(model);
                    for i:=1 to n do
                        begin
                            if Cam.model[i]= model then
                                writeln(Cam.model[i], ' ', Cam.px[i]:2:2, ' ', Cam.years[i]);
                        end;
                end;
            '2' :
                begin
                    n:= CountData(Cam);
                    max := 1;
                    for i := 2 to n do
                        if Cam.px[i] > Cam.px[max] then
                        max := i;
                    writeln(Cam.model[max], ' ', Cam.px[max]:2:2, ' ', Cam.years[max]);
                end;
            '3' :
                begin
                    n := CountData(Cam);
                    min := 1;
                    for i := 2 to n do
                        if Cam.px[i] < Cam.px[max] then
                        min := i;
                    writeln(Cam.model[min], ' ', Cam.px[min]:2:2, ' ', Cam.years[min]);
                end;
            '4' :
                begin
                    n := CountData(Cam);
                    writeln('iveskite metus');
                    readln(years);
                    for i:=1 to n do
                        begin
                            if Cam.years[i] = years then
                                writeln(Cam.model[i], ' ', Cam.px[i]:2:2, ' ', Cam.years[i]);
                        end;
                end;


            end;
        end;



//---------------------------------------------------------------
begin
    writeln('Sveiki! Programa skirta tvarkyti duomenu bazei, kurioje talpinama:');
    writeln('fotoaparato modelis, jo megapikseliu kiekis ir isleidimo metai.');
  repeat
    begin
        writeln('[1]Ivedimas [2]Rusiavimas [3]Pakeitimas/Prirasymas [4]Trinimas [5]Paieska');
        writeln('[0]Isejimas');
        Readln(x);
        case x of
        '1' :
            begin
                Cam := ReadData(Cam);
                PrintData(Cam);
            end;
        '2' :
            begin
                Cam := SortData(Cam);
                PrintData(Cam);
            end;
        '3' :
            begin
                ReinsertData(Cam);
                PrintData(Cam);
            end;
        '4' :
            begin
                DeleteData(Cam);
                CountData(Cam);
                PrintData(Cam);
            end;
        '5' :
            begin
                SearchData(Cam);
            end;
        '0' :
                Halt;
        end;
    end;
  until x = '0';
  readln;
end.
